;Music Synth 48K T.E. v1.0
;by Shiru (shiru@mail.ru) 10'09

;  SjAsmPlus

    device zxspectrum48

    org #8100

MAXROWS equ 2048    ;  
PAGEROW equ 16      ;  
PLAYER  equ 40000   ;  

STACK_A     equ #2d28
FP_TO_A     equ #2dd5
STACK_BC    equ #2d2b
FP_TO_BC    equ #2da2

CLS         equ #0d6b
BORDER      equ #5c48
ATTR_P      equ #5c8d

OP_NOP      equ #00
OP_XORA     equ #af



begin
    jp $+6
    jp editorStart

    ld hl,playerData
    ld de,PLAYER
    ld bc,600
    ldir
    ld hl,player9d33
    ld (#9c45),hl
    ld bc,100
    ldir

    ld hl,15616
    ld de,fontData
    ld bc,768
    ldir
    ld hl,envGfx
    ld bc,24
    ldir

    call makeScrTable
    call makeNoteNames
    call tuneClearAll

    call cls
    ld hl,#0508
    ld bc,#1670
    call setAttr
    inc h
    inc h
    ld bc,strTitle
    call strOut

    jp waitKey

editorStart
    call cls
    ld hl,#1204
    ld bc,strOctave
    call strOut
    ld hl,#1205
    ld bc,strEditor
    call strOut

    call viewOctave
    call viewAutoStep
    call viewTempo
    call viewLength
    call viewLoop
    call viewSize
    call viewCopy
 
editorLoop
    call viewPattern

pollKbd
    call waitKey
    /*ld hl,#1000
    ld d,0
    ld e,a
    push af
    call dec3NumOut
    pop af*/

    cp 11           ;UP
    jr nz,.key0
    ld bc,1
    call moveCurUp
    jp .keyE
.key0
    cp 10           ;DOWN
    jr nz,.key1
    ld bc,1
    call moveCurDown
    jp .keyE
.key1
    cp 4            ;PAGEUP
    jr nz,.key2
    ld bc,PAGEROW
    call moveCurUp
    jp .keyE
.key2
    cp 5            ;PAGEDOWN
    jr nz,.key3
    ld bc,PAGEROW
    call moveCurDown
    jp .keyE
.key2.0
    ld hl,MAXROWS-1
    ld (curRow),hl
    jp .keyE
.key3
    cp 8            ;LEFT
    jr nz,.key4
    ld hl,curCol
    ld a,(hl)
    dec a
    cp 4
    jr c,$+4
    ld a,4
    ld (hl),a
    jp .keyE
.key4
    cp 9            ;RIGHT
    jr nz,.key5
    ld hl,curCol
    ld a,(hl)
    inc a
    cp 5
    jr c,$+3
    xor a
    ld (hl),a
    jp .keyE
.key5
    cp 12           ;   
    jr nz,.key6
    call rowDelete
    jp .keyE
.key6
    cp 13           ;   
    jr nz,.key7
    call playFromCur
    jp .keyE
.key7
    cp 37           ; autostep
    jr nz,.key8
    ld hl,#1e05
    ld de,(autoStep)
    ld b,2
    call numInput
    ld bc,1
    ld de,100
    call minMax
    ld (autoStep),hl
    call viewAutoStep
    jp .keyE
.key8
    cp 39           ; tempo
    jr nz,.key10
    ld hl,#1d06
    ld a,(tuneTempo)
    ld d,0
    ld e,a
    ld b,3
    call numInput
    ld bc,20
    ld de,255
    call minMax
    ld a,l
    ld (tuneTempo),a
    call viewTempo
    jp .keyE
.key10
    cp 199          ;HOME
    jr nz,.key12
    ld hl,0
    ld (curRow),hl
    jp .keyE
.key12
    cp 200          ;END
    jr nz,.key13
    ld hl,(tuneLength)
    dec hl
    ld (curRow),hl
    jp .keyE
.key13
    cp 201          ;INSERT
    jr nz,.key14
    call rowInsert
    jp .keyE
.key14
    cp 15           ;DELETE
    jr nz,.key15
    call getNoteAdr
    ld (hl),0
    call autoCurDown
    jp .keyE
.key15
    cp 32           ;MENU
    jr nz,.key16
    jp menuStart
.key16
    cp 108          ;  
    jr nz,.key17
    ld bc,(curRow)
    ld (tuneLoop),bc
    call viewLoop
    jp .keyE
.key17
    cp 7            ; 
    jr nz,.key20
    call getNoteAdr
    jr nz,.key19.0
    ld de,MAXROWS
    add hl,de
.key19.0
    ld a,(hl)
    or a
    jr z,$+5
    ld (curEnv),a
    jp envelopeEditor
.key20
    cp 41           ;  
    jr nz,.key100
    ld hl,#1c07
    ld de,(tuneLength)
    ld b,4
    call numInput
    ld bc,24
    ld de,MAXROWS
    call minMax
    ld (tuneLength),hl
    call viewLength
    ld hl,(tuneLoop)
    ld bc,0
    ld de,(tuneLength)
    dec de
    call minMax
    ld (tuneLoop),hl
    call viewLoop
    ld hl,(curRow)
    ld bc,0
    ld de,(tuneLength)
    dec de
    call minMax
    ld (curRow),hl
    jp .keyE
.key100
    ld c,a          ; 
    call getNoteAdr
    ld a,c
    jr nz,.key101
    push hl
    call noteKeys
    push af
    push bc
    call viewOctave
    pop bc
    pop af
    pop hl
    jr nz,.keyE
    ld (hl),c
    jr .key101.0
.key101
    call hexKeys    ; 
    jr nz,.keyE
    ld (hl),c
    ld a,c
    or a
    jr z,$+5
    ld (curEnv),a
.key101.0
    ld bc,(curRow)
    push bc
    call autoCurDown
    pop bc
    ld de,(curRow)
    push de
    push bc
    call viewPattern
    pop bc
    ld (curRow),bc
    call playRow
    pop de
    ld (curRow),de
.keyE
    jp editorLoop

; 

viewPattern
    di
    ld hl,(curRow)
    ld bc,12
    scf
    ccf
    sbc hl,bc
    jr nc,$+5
    ld hl,0
    push hl
    ld hl,(tuneLength)
    ld bc,24
    sbc hl,bc
    ld b,h
    ld c,l
    pop hl
    ld a,h
    cp b
    jr c,.loop0
    ld a,l
    cp c
    jr c,.loop0
    ld h,b
    ld l,c
.loop0
    ld b,h
    ld c,l
    ld (attrCur.row),bc
    ld hl,#0100
    ld a,24
.loop1
    push hl
    push bc
    push af

    ld (.cur0),bc
    ld (.cur1),bc
    ld (.cur2),bc
    ld (.cur3),bc
    ld (.cur4),bc
 
    ld d,b
    ld e,c
    push hl
    call dec4NumOut
    pop hl
    ld h,6
    call scrPos

    push hl
.cur0=$+1
    ld hl,0
    ld bc,tuneData+(MAXROWS*0)
    add hl,bc
    ld b,tagName/256
    ld c,(hl)
    pop hl
 
    ld a,(bc)
    inc b
    call chrOutA
    ld a,(bc)
    inc b
    call chrOutA
    ld a,(bc)
    call chrOutA
    push hl
.cur1=$+1
    ld hl,0
    ld bc,tuneData+(MAXROWS*1)
    add hl,bc
    ld a,(hl)
    pop hl
    call chrOutHex
    inc l

    push hl
.cur2=$+1
    ld hl,0
    ld bc,tuneData+(MAXROWS*2)
    add hl,bc
    ld b,tagName/256
    ld c,(hl)
    pop hl
 
    ld a,(bc)
    inc b
    call chrOutA
    ld a,(bc)
    inc b
    call chrOutA
    ld a,(bc)
    call chrOutA
    push hl
.cur3=$+1
    ld hl,0
    ld bc,tuneData+(MAXROWS*3)
    add hl,bc
    ld a,(hl)
    pop hl
    call chrOutHex
    inc l

    push hl
.cur4=$+1
    ld hl,0
    ld bc,tuneData+(MAXROWS*4)
    add hl,bc
    ld a,(hl)
    pop hl
    call chrOutHex

    pop af
    pop bc
    pop hl
    inc l
    inc bc
    dec a
    jp nz,.loop1

attrCur
    ld hl,#5800
.row=$+1
    ld de,0
    ld a,24
.loop0
    push af
    push de
    push hl
    ld bc,(curRow)
    ld a,d
    cp b
    jr nz,.loop1
    ld a,e
    cp c
    jr nz,.loop1
    ld b,7+8
    jr .loop2
.loop1
    ld b,7
.loop2
    ld a,e
    and 3           ;  
    ld a,b
    jr nz,$+4
    or 64
    dup 18
    ld (hl),a
    inc l
    edup
    org $-1
    ld b,0
    pop hl
    push hl
    and 63
    cp 7+8
    jr nz,.loop4
    ld a,(curCol)   ;   
    push hl
    ld hl,attrOff
    ld c,a
    add hl,bc
    add hl,bc
    ld c,(hl)
    inc hl
    ld a,(hl)
    pop hl
    add hl,bc
    ld c,64+48
    ld (hl),c
    or a
    jr z,.loop4
    inc l
    ld (hl),c
    inc l
    ld (hl),c
.loop4
    pop hl
    pop de
    pop af
    ld c,32
    add hl,bc
    inc de
    dec a
    jr nz,.loop0
    ei
    ret

; 

viewOctave
    ld hl,#1f04
    ld a,(curOctave)
    jp dec1NumOut
viewAutoStep
    ld hl,#1e05
    ld de,(autoStep)
    jp dec2NumOut
viewTempo
    ld hl,#1d06
    ld a,(tuneTempo)
    ld d,0
    ld e,a
    jp dec3NumOut
viewLength
    ld hl,#1c07
    ld de,(tuneLength)
    jp dec4NumOut
viewLoop
    ld hl,#1c08
    ld de,(tuneLoop)
    jp dec4NumOut
viewSize
    ld hl,#1c09
    ld de,(tuneSize)
    ld a,d
    or e
    jp nz,dec3NumOut
    ld b,3
.loop0
    call scrPos
    ld e,'-'
    call chrOut
    djnz $-5
    ret
viewCopy
    ld hl,#1c0c
    ld de,(copyBufLen)
    ld a,d
    or e
    jp nz,dec4NumOut
    ld b,4
    jr viewSize.loop0

; 

menuStart
    ld hl,#5800
    ld bc,#0300
.loop0
    ld a,(hl)
    and %00111000
    ld e,1
    jr z,$+10
    and %00110000
    ld e,8
    jr z,$+4
    ld e,24
    ld (hl),e
    inc hl
    dec bc
    ld a,b
    or c
    jr nz,.loop0

    ld hl,#0017
    ld bc,#204f
    call setAttr
    ld bc,strMainMenu
    call strOut
    ld hl,#0117
    ld bc,#0170
    call setAttr
    ld h,#06
    call setAttr
    ld h,#0b
    call setAttr
    ld h,#11
    call setAttr
    ld h,#16
    call setAttr
    ld h,#1b
    call setAttr

.loop1
    call waitKey
 
    cp 'f'          ;FILE
    jr nz,.key0
    jp fileMenuStart
.key0
    cp 'c'          ;COPY
    jr nz,.key1
    ld hl,#0017
    ld bc,#204f
    call setAttr
    ld bc,strCopy
    call strOut
    ld hl,#0f17
    ld de,(copyLen)
    ld b,4
    call numInput
    ld bc,1
    ld de,MAXROWS
    call minMax
    ld (copyLen),hl
    call blockCopy
    jp editorStart
.key1
    cp 'p'          ;PASTE
    jr nz,.key2
    call blockPaste
    jp editorStart
.key2
    cp 'h'          ;HEAR
    jr nz,.key3
    ld hl,#0017
    ld bc,#204f
    call setAttr
    ld bc,strPlay
    call strOut
    halt
    halt
    halt
    call playFromStart
    jp editorStart
.key3
    cp 'n'          ;NAME
    jr nz,.key4
    ld hl,#0017
    ld bc,#2047
    call setAttr
    ld de,tuneName
    ld b,32
    call strInput
    jp editorStart
.key4
    cp 'i'          ;INFO
    jr nz,.key5
    jp showHelp
.key5
    cp 32
    jp nz,.loop1
    jp editorStart

; 

fileMenuStart
    ld hl,#0017
    ld bc,#204f
    call setAttr
    ld bc,strFileMenu
    call strOut
    ld hl,#0117
    ld bc,#0170
    call setAttr
    ld h,#05
    call setAttr
    ld h,#0a
    call setAttr

.loop0
    call waitKey

.key0
    cp 'n'          ;NEW
    jr nz,.key1
    call confirmDialog
    ld a,e
    or a
    jr nz,.key0.0
    call tuneClearAll
    jp editorStart
.key0.0
    dec a
    jp nz,editorStart
    call tuneClearTrack
    jp editorStart
.key1
    cp 'l'          ;LOAD
    jr nz,.key2
    call settingsClear
    ld bc,0
    ret				;to BASIC
.key2
    cp 's'          ;SAVE
    jr nz,.key3
    ld bc,1
    ret				;to BASIC
.key3
    cp 32
    jr nz,.loop0
    jp editorStart

;

confirmDialog
    ld hl,#0017
    ld bc,#2057
    call setAttr
    ld bc,strConfirm
    call strOut
    ld hl,#0617
    ld bc,#0170
    call setAttr
    ld hl,#0a17
    call setAttr
    ld hl,#1017
    call setAttr

.loop0
    call waitKey
    ld e,0
    cp 'a'
    ret z
    inc e
    cp 't'
    ret z
    inc e
    cp 'c'
    ret z
    jr .loop0

; 

showHelp
    xor a
    ld (.row),a
    call cls
    ld bc,strHelp
.loop0
    ld a,(bc)
    cp 255
    jr z,.loop4
    ld h,0
.row=$+1
    ld l,0
    ld (.pos),hl
    call scrPos
    ld e,0
.loop1
    ld a,(bc)
    inc bc
    push de
    push af
    call chrOutA
    pop af
    pop de
    inc e
    cp ':'
    jr nz,.loop1
    push hl
    push bc
.pos=$+1
    ld hl,0
    ld b,e
    ld c,64+6
    call setAttr
    pop bc
    pop hl
.loop2
    ld a,(bc)
    inc bc
    cp 32
    jr c,.loop3
    call chrOutA
    jr .loop2
.loop3
    ld hl,.row
    inc (hl)
    dec a
    jr nz,.loop3
    jr .loop0
.loop4
    call waitKey
    jp editorStart

; 

envelopeEditor
    call cls
    ld hl,#0100
    ld bc,strEnvelope
    call strOut
    ld hl,#1000
    ld bc,strOctave
    call strOut

envUpdate
    ld hl,#0b00
    ld a,(curEnv)
    ld d,0
    ld e,a
    call dec2NumOut

    call drawEnvelope

envDrawCur
    ld hl,#5841
    ld de,#0020
    ld bc,#1e00
.loop0
    push hl
    push bc
    ld a,(curEnvCol)
    cp c
    jr z,.loop1
    ld a,7
    ld b,8
    ld (hl),a
    add hl,de
    djnz $-2
    ld a,7+64
    ld b,8
    jr .loop2
.loop1
    ld a,7+64+8
    ld b,16
.loop2
    ld (hl),a
    add hl,de
    djnz $-2
    pop bc
    pop hl
    inc l
    inc c
    djnz .loop0

envPollKbd
    ld hl,#1800
    ld a,(curOctave)
    call dec1NumOut

    call waitKey
 
    cp 8            ;LEFT
    jr nz,.key0
    ld hl,curEnvCol
    ld a,(hl)
    or a
    jr z,$+3
    dec (hl)
    jp envDrawCur
.key0
    cp 9            ;RIGHT
    jr nz,.key1
    ld hl,curEnvCol
    ld a,(hl)
    cp 29
    jr nc,$+3
    inc (hl)
    jp envDrawCur
.key1
    cp 7            ;   
    jr nz,.key2
    jp editorStart
.key2
    cp 11           ;UP
    jr nz,.key3
    ld a,(curEnvCol)
    call getCurEnvAdr
    ld a,(hl)
    cp 31
    jr nc,$+3
    inc (hl)
.key2.0
    ld a,(hl)
    ld h,c
    inc h
    ld c,a
    call drawEnvColumn
    jp .keyE
.key3
    cp 10           ;DOWN
    jr nz,.key4
    ld a,(curEnvCol)
    call getCurEnvAdr
    ld a,(hl)
    or a
    jr z,$+3
    dec (hl)
    jr .key2.0
.key4
    cp 4            ;PAGE UP
    jr nz,.key5
    ld hl,curEnv
    ld a,(hl)
    cp 1
    jr z,$+3
    dec (hl)
    jp envUpdate
.key5
    cp 5            ;PAGE DOWN
    jr nz,.key6
    ld hl,curEnv
    ld a,(hl)
    cp 15
    jr nc,$+3
    inc (hl)
    jp envUpdate
.key6
    cp 12           ;  
    jr nz,.key7
    ld a,(curEnvCol)
    cp 29
    jp z,.keyE
    push af
    call getCurEnvAdr
    pop af
    ld c,a
    ld a,29
    sub c
    ld b,0
    ld c,a
    ld d,h
    ld e,l
    inc hl
    ldir
    jp envUpdate
.key7
    cp 201          ;  
    jr nz,.key8
    xor a
    call getCurEnvAdr
    ld bc,29
    add hl,bc
    ld a,(curEnvCol)
    ld c,a
    ld a,29
    sub c
    jp z,.keyE
    ld c,a
    ld d,h
    ld e,l
    dec hl
    lddr
    ld hl,curEnvCol
    ld a,(hl)
    cp 29
    jr nc,$+3
    inc (hl)
    jp envUpdate
.key8
    call noteKeys
    jr nz,.keyE

    ld hl,plrData
    ld de,#ff00

    ld (playerStartA),hl
    ld (hl),d
    inc hl
    ld a,(curEnv)
    ld b,a
    ld a,c
    cp 49
    ld a,b
    jr nz,$+3
    xor a
    ld (hl),a
    inc hl
    push bc
    dec c
    ld b,noteFreq/256
    ld a,(bc)
    pop bc
    ld (hl),a
    inc hl
    ld (hl),#10
    inc hl
    ld (playerLoopA),hl
    ld (hl),d
    inc hl
    ld (hl),e
    inc hl
    ld (hl),e
    inc hl
    ld (hl),e
    inc hl

    ld (playerStartB),hl
    ld (hl),d
    inc hl
    ld (hl),e
    inc hl
    ld (playerLoopB),hl
    ld (hl),e
    inc hl
    ld (hl),e
    inc hl

    ld (playerStartC),hl
    ld a,c
    cp 49
    ld a,b
    jr z,$+3
    xor a
    ld (hl),a
    inc hl
    ld (hl),#01
    inc hl
    ld (playerLoopC),hl
    ld (hl),e
    inc hl
    ld (hl),e

    call playerPlayRelease
.keyE
    jp envPollKbd

;   
;: H=x,L=y,C= 0..31

drawEnvColumn
    push hl
    push de
    push bc
    ld l,2
    call scrPos
    ld b,16
.loop0
    ld a,c
    srl a
    inc a
    cp b
    ld a,128
    jr nz,.loop1
    bit 0,c
    ld a,129
    jr z,.loop1
    ld a,130
.loop1
    push hl
    call chrOutA
    pop hl
    call downChr
    djnz .loop0
    pop bc
    pop de
    pop hl
    ret

;   

drawEnvelope
    xor a
    call getCurEnvAdr
    ex de,hl
    ld h,1
    ld b,30
.loop0
    push bc
    ld a,(de)
    ld c,a
    call drawEnvColumn
    pop bc
    inc h
    inc de
    djnz .loop0
    ret

;   
;: A=   
;: HL=, C=A

getCurEnvAdr
    ld b,0
    ld c,a
    push bc
    ld a,(curEnv)
    ld h,b
    ld l,a
    add hl,hl
    add hl,hl
    add hl,hl
    add hl,hl
    add hl,hl
    add hl,bc
    ld bc,envData
    add hl,bc
    pop bc
    ret

;    

tuneClearAll
    ld hl,envData
    ld b,16
.loop0
    push bc
    ld bc,#1e00
    ld (hl),c
    inc hl
    djnz $-2
    dec b
    ld (hl),b
    inc hl
    ld (hl),b
    inc hl
    pop bc
    djnz .loop0
 
tuneClearTrack
    ld hl,tuneData
    ld de,tuneData+1
    ld bc,MAXROWS*5-1
    ld (hl),0
    ldir
 
settingsClear
    ld bc,0
    ld (curRow),bc
    ld a,0
    ld (curCol),a
    ld (curEnvCol),a
    ld a,1
    ld (curEnv),a
    ld a,2
    ld (curOctave),a
    ld bc,1
    ld (autoStep),bc
    ld bc,8
    ld (copyLen),bc
    ld bc,0
    ld (copyBufLen),bc
    ld bc,256
    ld (tuneLength),bc
    ld a,#40
    ld (tuneTempo),a
    ld bc,0
    ld (tuneSize),bc
    ld bc,0
    ld (tuneLoop),bc

    ld hl,tuneName
    ld de,tuneName+1
    ld bc,31
    ld (hl),32
    ldir
 
    ret

;     
;: A= 
;:  A=0, = 

noteKeys
    ld hl,noteKeyTable
    ld b,noteTable-noteKeyTable
.key0
    cp (hl)
    jr z,.key1
    inc hl
    djnz .key0
    or a
    ret
.key1
    ld bc,noteTable-noteKeyTable
    add hl,bc
    ld a,(hl)
    cp 128
    jr c,.key2
    sub 127
    ld (curOctave),a
    or a
    ret
.key2
    cp 49
    jr z,.key3
    push af
    ld a,(curOctave)
    ld b,a
    pop af
    sub 12
    add a,12
    djnz $-2
    cp 48
    jr c,$+4
    ld a,47
    inc a
.key3
    ld c,a
    xor a
    ret

;     0..9  A..F
;: A= 
;:  A=0, =

hexKeys
    cp '0'
    jr c,.loop1
    cp 'g'
    jr nc,.loop1
    cp 'a'
    ld b,'a'-10
    jr nc,.loop0
    cp ':'
    jr nc,.loop1
    ld b,'0'
.loop0
    sub b
    ld c,a
    xor a
.loop1
    or a
    ret

;     
;: A=0  1 (  ), HL=

getNoteAdr
    ld a,(curCol)
getColAdr
    push bc
    push de
    ld de,(curRow)
    ld c,0
    cp c
    ld hl,tuneData+(MAXROWS*0)
    jr z,.note
    inc c
    cp c
    ld hl,tuneData+(MAXROWS*1)
    jr z,.env
    inc c
    cp c
    ld hl,tuneData+(MAXROWS*2)
    jr z,.note
    inc c
    cp c
    ld hl,tuneData+(MAXROWS*3)
    jr z,.env
    ld hl,tuneData+(MAXROWS*4)
.env
    ld a,1
    jr $+3
.note
    xor a
    add hl,de
    pop de
    pop bc
    or a
    ret

;   

blockCopy
    ld hl,(curRow)
    ld bc,(copyLen)
    add hl,bc
    push bc
    ld bc,-MAXROWS
    add hl,bc
    pop bc
    jr nc,.loop0
    ld hl,MAXROWS
    ld bc,(curRow)
    scf
    ccf
    sbc hl,bc
    ld b,h
    ld c,l
.loop0
    ld (copyBufLen),bc
    ld a,(curCol)
    srl a
    add a,a
    ld (copyBufCol),a
    cp 4
    push bc
    jr z,.loop1
    push af
    call getColAdr
    ld de,copyBuf
    ldir
    pop af
    inc a
.loop1
    call getColAdr
    pop bc
    ld de,copyBuf+MAXROWS
    ldir
    ret

;   

blockPaste
    ld bc,(copyBufLen)
    ld a,b
    or c
    ret z
    ld a,(curCol)
    srl a
    add a,a
    push bc
    cp 4
    jr z,.loop0
    push af
    call getColAdr
    ld de,copyBuf
    ex de,hl
    ld a,(copyBufCol)
    cp 4
    jr z,$+4
    ldir
    pop af
    inc a
.loop0
    call getColAdr
    pop bc
    ld de,copyBuf+MAXROWS
    ex de,hl
    ldir
    ret

;    

rowInsert
    ld hl,MAXROWS
    ld bc,(curRow)
    sbc hl,bc
    ld b,h
    ld c,l
    ld a,(curCol)
    srl a
    add a,a
    push af
    call getColAdr
    call .move
    pop af
    cp 4
    ret z
    ld de,MAXROWS
    add hl,de
.move
    push hl
    push bc
    add hl,bc
    dec hl
    ld d,h
    ld e,l
    dec hl
    dec bc
    ld a,b
    or c
    jr z,$+4
    lddr
    pop bc
    pop hl
    ld (hl),0
    ret

;   

rowDelete
    ld hl,MAXROWS
    ld bc,(curRow)
    sbc hl,bc
    ld b,h
    ld c,l
    ld a,(curCol)
    srl a
    add a,a
    push af
    call getColAdr
    call .move
    pop af
    cp 4
    ret z
    ld de,MAXROWS
    add hl,de
.move
    push hl
    push bc
    ld d,h
    ld e,l
    inc hl
    dec bc
    ld a,b
    or c
    jr z,$+4
    ldir
    dec hl
    ld (hl),0
    pop bc
    pop hl
    ret

;  

playRow
    ld a,1
    ld bc,tuneData+(MAXROWS*1)
    call getColEnv
    ld e,a
    ld a,3
    ld bc,tuneData+(MAXROWS*3)
    call getColEnv
    ld d,a
 
    ld hl,plrData

    ld (playerStartA),hl
    push hl
    xor a
    call getColAdr
    ld a,(hl)
    pop hl
    or a
    jr nz,$+4
    ld a,49
    ld (hl),#ff
    inc hl
    ld (hl),e
    inc hl
    ld b,noteFreq/256
    ld c,a
    dec c
    ld a,(bc)
    ld (hl),a
    inc hl
    ld (hl),#10
    inc hl
    ld (playerLoopA),hl
    xor a
    ld (hl),a
    inc hl
    ld (hl),a
    inc hl

    ld (playerStartB),hl
    push hl
    ld a,2
    call getColAdr
    ld a,(hl)
    pop hl
    or a
    jr nz,$+4
    ld a,49
    ld (hl),#ff
    inc hl
    ld (hl),d
    inc hl
    ld b,noteFreq/256
    ld c,a
    dec c
    ld a,(bc)
    ld (hl),a
    inc hl
    ld (hl),#10
    inc hl
    ld (playerLoopB),hl
    xor a
    ld (hl),a
    inc hl
    ld (hl),a
    inc hl
 
    ld (playerStartC),hl
    push hl
    ld a,4
    call getColAdr
    ld a,(hl)
    pop hl
    ld (hl),a
    inc hl
    ld (hl),#01
    inc hl
    ld (playerLoopC),hl
    xor a
    ld (hl),a
    inc hl
    ld (hl),a
    inc hl

    jp playerPlayRelease

getColEnv
    call getColAdr
    push hl
    sbc hl,bc
    ld b,h
    ld c,l
    inc bc
    pop hl
.loop0
    ld a,(hl)
    or a
    ret nz
    dec hl
    dec bc
    ld a,b
    or c
    jp nz,.loop0
    ld a,1
    ret

;      

playFromCur
    ld hl,playerPlayRelease
    ld bc,(curRow)
    jr compileTune

;      

playFromStart
    ld hl,playerPlayPress
    ld bc,0

;       

compileTune
    di
    push iy

    ld (.playerType),hl
 
    ld hl,(tuneLoop)
    xor a
    sbc hl,bc
    jr c,.loop0
    ld hl,playerStartA ;  
    ld (.chnA0),hl
    ld hl,playerLoopA
    ld (.chnA1),hl
    ld hl,playerStartB
    ld (.chnB0),hl
    ld hl,playerLoopB
    ld (.chnB1),hl
    ld hl,playerStartC
    ld (.chnC0),hl
    ld hl,playerLoopC
    ld (.chnC1),hl
    ld (cmpLen0),bc
    ld hl,(tuneLoop)
    xor a
    sbc hl,bc
    ld (cmpLen1),hl
    ld hl,(tuneLength)
    ld bc,(tuneLoop)
    xor a
    sbc hl,bc
    ld (cmpLen2),hl
    jr .loop1
.loop0              ;  
    ld hl,playerLoopA
    ld (.chnA0),hl
    ld hl,playerStartA
    ld (.chnA1),hl
    ld hl,playerLoopB
    ld (.chnB0),hl
    ld hl,playerStartB
    ld (.chnB1),hl
    ld hl,playerLoopC
    ld (.chnC0),hl
    ld hl,playerStartC
    ld (.chnC1),hl
    ld hl,(tuneLoop)
    ld (cmpLen0),hl
    push bc
    ld h,b
    ld l,c
    ld bc,(tuneLoop)
    xor a
    sbc hl,bc
    ld (cmpLen1),hl
    ld hl,(tuneLength)
    pop bc
    xor a
    sbc hl,bc
    ld (cmpLen2),hl
.loop1

    ld hl,plrData

    ld de,tuneData+(MAXROWS*0)
    ld ix,tuneData+(MAXROWS*1)
    call cmpToneInit
    ld bc,(cmpLen0)
    call cmpTone
    jp z,.memFull
    ld bc,(cmpLen1)
.chnA0=$+1
    ld (0),hl
    call cmpTone
    jp z,.memFull
    ld bc,(cmpLen2)
.chnA1=$+1
    ld (0),hl
    call cmpTone
    jp z,.memFull
    call cmpToneEndM

    ld de,tuneData+(MAXROWS*2)
    ld ix,tuneData+(MAXROWS*3)
    call cmpToneInit
    ld bc,(cmpLen0)
    call cmpTone
    jp z,.memFull
    ld bc,(cmpLen1)
.chnB0=$+1
    ld (0),hl
    call cmpTone
    jp z,.memFull
    ld bc,(cmpLen2)
.chnB1=$+1
    ld (0),hl
    call cmpTone
    jp z,.memFull

    ld ix,tuneData+(MAXROWS*4)
    ld bc,(cmpLen0)
    call cmpPerc
    jp z,.memFull
    ld bc,(cmpLen1)
.chnC0=$+1
    ld (0),hl
    call cmpPerc
    jp z,.memFull
    ld bc,(cmpLen2)
.chnC1=$+1
    ld (0),hl
    call cmpPerc
    jp z,.memFull

    push hl
    ld bc,100
    call STACK_BC
    pop hl
    ld a,h
    sub plrData/256
    ld b,a
    ld c,l
    call STACK_BC
    ld bc,tuneName-plrData
    call STACK_BC
    rst #28
    db #05 ;/
    db #04 ;*
    db #38 ;end
    call FP_TO_BC
    ld (tuneSize),bc
 
    call viewSize

    pop iy

.playerType=$+1
    jp playerPlayPress

.memFull
    ld bc,100
    ld (tuneSize),bc
    call viewSize
    pop iy
    ei
    ld a,2
    out (#fe),a
    ld b,4
    halt
    djnz $-1
    xor a
    out (#fe),a
    ret

cmpToneInit
    ld a,1
    ld (cmpTone.env),a
    ld a,254
    ld (cmpTone.prevEnv),a
    ret

cmpTone
    ld a,b
    or c
    jr nz,$+4
    inc a
    ret
    ld a,49
    ld (cmpTone.note),a
    ld iy,0
    ld a,(ix)
    or a
    jr nz,.loop0
    ld a,(.env)
    ld (hl),#ff
    inc l
    ld (hl),a
    inc hl
.loop0
    ld a,(ix)
    or a
    jr z,.loop1
    ld (.env),a
.loop1
    ld a,(de)
    or a
    jr z,.loop4
    push af
.note=$+1
    ld a,0
    or a
    jr z,.loop2
    call cmpToneAddNote
    ret z
.loop2
.env=$+1
    ld a,0
.prevEnv=$+1
    cp 0
    jr z,.loop3
    ld (.prevEnv),a
    ld (hl),#ff     ;
    inc l
    ld (hl),a
    inc hl
.loop3
    pop af
    ld (.note),a
    ld iy,0
.loop4
    inc de
    inc ix
    inc iy
    dec bc
    ld a,b
    or c
    jp nz,.loop0
    ld a,iyh
    or iyl
    ld a,(.note)
    jr nz,cmpToneAddNote
    xor a
    inc a
    ret

cmpToneAddNote
    push bc
    ld b,noteFreq/256
    ld c,a
    dec c
    ld a,(bc)
    ld (.addNote0),a
    ld a,iyh
    or a
.addNote0=$+1
    ld a,0
    jr z,.addNote2
    ld b,iyh
    sla b
    ld c,#80
.addNote1
    ld (hl),a
    inc l
    xor a
    ld (hl),c
    inc hl
    djnz .addNote1
.addNote2
    ld b,a
    ld a,iyl
    or a
    ld a,b
    pop bc
    jr nz,$+5
    xor a
    inc a
    ret
    ld (hl),a
    inc l
    ld a,iyl
    ld (hl),a
    inc hl
    ld a,h
    cp (tuneName/256)-1
    ret

cmpToneEndM
    xor a
    ld (hl),a
    inc l
    ld (hl),a
    inc hl
    ret

cmpPerc
    ld a,b
    or c
    jr nz,$+4
    inc a
    ret
    ld a,255
    ld (.env),a
    ld iy,0
.loop0
    ld a,(ix)
    or a
.env=$+1
    ld a,0
    jr nz,.loop1
    cp (ix)
    jr z,.loop3
    cp 255
    jr z,.loop2
.loop1
    call .addDrum
    ret z
.loop2
    ld a,(ix)
    ld (.env),a
    ld iy,0
.loop3
    inc ix
    inc iy
    dec bc
    ld a,b
    or c
    jp nz,.loop0
 
    ld a,iyh
    or iyl
    ld a,(.env)
    jr nz,.addDrum
    xor a
    inc a
    ret
 
.addDrum
    ld e,a
    ld a,iyh
    or a
    jr z,.addDrum1
    push bc
    add a,a
    ld b,a
    ld c,#80
.addDrum0
    ld (hl),e
    inc l
    ld (hl),c
    inc hl
    djnz .addDrum0
    pop bc
.addDrum1
    ld a,iyl
    or a
    jr nz,$+5
    xor a
    inc a
    ret
    ld (hl),e
    inc l
    ld a,iyl
    ld (hl),a
    inc hl
    ld a,h
    cp (tuneName/256)-1
    ret

; #9d33

player9d33
    ld hl,(playerStartA)
    ld (#9e3a),hl
    ld hl,(playerStartB)
    ld (#9e3c),hl
    ld hl,(playerStartC)
    ld (#9e3e),hl
    call #9d4f
    call #9d9b
    jp #9ddf

; 

playerPlayRelease
    ld a,#c2        ;jp nz
    jr $+4
playerPlayPress
    ld a,#ca        ;jp z
    ld (#9cd7),a
    ld a,(tuneTempo)
    ld (#9e55),a
    ld hl,envData
    ld (#9e51),hl
    ld hl,(playerLoopA)
    ld (#9e34),hl
    ld hl,(playerLoopB)
    ld (#9e36),hl
    ld hl,(playerLoopC)
    ld (#9e38),hl
    jp PLAYER

;  
;: BC=  

moveCurUp
    ld hl,(curRow)
    sbc hl,bc
    jr nc,$+5
    ld hl,0
    ld (curRow),hl
    ret

;  
;: BC=  

autoCurDown
    ld bc,(autoStep)
moveCurDown
    ld hl,(curRow)
    add hl,bc
    ld bc,(tuneLength)
    sbc hl,bc
    jr c,$+5
    ld hl,-1
    add hl,bc
    ld (curRow),hl
    ret

; 
;: H=x,L=y,DE=,B=

strInput
    ld a,OP_NOP
    ld (strInputM.mode),a
strInputM
    xor a
    ld (.cur),a
    ld (.off),de
.loop0
    push hl
    push de
    push bc
    ld c,#4f
    call setAttr
    push bc
    push hl
.cur=$+1
    ld a,0
    add a,h
    ld h,a
    ld bc,#0170
    call setAttr
    pop hl
    pop bc
    call scrPos
.off=$+1
    ld de,0
.loop1
    ld a,(de)
    inc de
    push de
    call chrOutA
    pop de
    djnz .loop1
 
    call waitKey
    pop bc
    pop de
    pop hl
 
    cp 13           ;ENTER
    ret z
.key0
    cp 8            ;LEFT
    jr nz,.key1
.key0.0
    ld a,(.cur)
    or a
    jr z,.keyE
    dec a
    ld (.cur),a
    dec de
    jr .keyE
.key1
    cp 9            ;RIGHT
    jr nz,.key2
.key1.0
    ld a,(.cur)
    inc a
    cp b
    jr nc,.keyE
    ld (.cur),a
    inc de
    jr .keyE
.key2
    cp '0'          ; 
    jr c,.key3
    cp ':'
    jr nc,.key3
    ld (de),a
    jr .key1.0
.key3
.mode=$
    nop
    cp 32           ; 
    jr c,.key4
    cp 128
    jr nc,.key4
    ld (de),a
    jr .key1.0
.key4
    cp 12           ; 
    jr nz,.keyE
    ld a,32
    ld (de),a
    jr .key0.0
.keyE
    jr .loop0

; 
;: H=x,L=y,B= ,DE=
;: HL=

numInput
    push hl
    push bc
    ld hl,#5800
    ld bc,#0300
.loop0
    ld a,(hl)
    and %00111000
    cp %00110000
    jr nz,$+4
    ld (hl),64+7+8
    inc hl
    dec bc
    ld a,b
    or c
    jr nz,.loop0
    ex de,hl
    ld de,strNumber
    ld bc,-10000
    call .setDigit
    ld bc,-1000
    call .setDigit
    ld bc,-100
    call .setDigit
    ld bc,-10
    call .setDigit
    ld a,l
    add a,'0'
    ld (de),a
    pop bc
    xor a
    ld a,b
    ld c,b
    ld b,0
    ld hl,strNumber+5
    sbc hl,bc
    ex de,hl
    ld b,a
    pop hl
    ld a,OP_XORA
    ld (strInputM.mode),a
    push hl
    push bc
    call strInputM
    pop bc
    pop hl
    ld c,64+7
    call setAttr
    ld de,strNumber
    ld hl,0
    ld bc,10000
    call .mulDigit
    ld bc,1000
    call .mulDigit
    ld bc,100
    call .mulDigit
    ld bc,10
    call .mulDigit
    ld a,(de)
    sub '0'
    ld c,a
    add hl,bc
    ret

.setDigit
    ld a,'0'
.setDigit0
    add hl,bc
    jr nc,.setDigit1
    inc a
    jr .setDigit0
.setDigit1
    sbc hl,bc
    ld (de),a
    inc de
    ret

.mulDigit
    ld a,(de)
    inc de
    sub '0'-1
.mulDigit0
    dec a
    ret z
    add hl,bc
    jr .mulDigit0

;    
;: HL=,BC=,DE=
;: HL=

minMax
    push hl
    xor a
    sbc hl,bc
    pop hl
    jr nc,$+4
    ld h,b
    ld l,c
    push hl
    xor a
    sbc hl,de
    pop hl
    jr c,$+4
    ld h,d
    ld l,e
    ret

;  
;: H=x,L=y,C=,B=

setAttr
    push bc
    push de
    push hl
    ld e,h
    ld d,#58
    ld h,#00
    add hl,hl
    add hl,hl
    add hl,hl
    add hl,hl
    add hl,hl
    add hl,de
.loop0
    ld (hl),c
    inc l
    djnz .loop0
    pop hl
    pop de
    pop bc
    ret

;   

cls
    xor a
    out (#fe),a
    ld a,64+7
    ld (BORDER),a
    ld (ATTR_P),a
    jp CLS

;   

makeScrTable
    ld hl,#4000
    ld de,scrTable
    ld b,24
.loop0
    ld a,l
    ld (de),a
    set 7,e
    ld a,h
    ld (de),a
    res 7,e
    inc e
    call downChr
    djnz .loop0

    ret

;  

makeNoteNames
    ld hl,tagName
    ld a,'.'
.loop0
    ld (hl),a
    inc h
    ld (hl),a
    inc h
    ld (hl),a
    dec h
    dec h
    inc l
    jr nz,.loop0
 
    ld c,'1'
    inc l
.loop1
    ld de,noteName
    ld b,12
.loop2
    ld a,(de)
    ld (hl),a
    inc h
    inc de
    ld a,(de)
    ld (hl),a
    inc h
    inc de
    ld (hl),c
    dec h
    dec h
    inc l
    djnz .loop2
    inc c
    ld a,c
    cp '5'
    jr nz,.loop1
 
    ld (hl),'R'

    ret

;    
;: H=x,L=y
;: HL=

scrPos
    push de
    ld e,h
    ld h,scrTable/256
    ld d,(hl)
    set 7,l
    ld h,(hl)
    ld l,d
    ld d,0
    add hl,de
    pop de
    ret

;   
;  DOWN_HL+ by Spencer Winsent

downChr
    ld a,l
    sub #e0
    ld l,a
    sbc a,a
    and #f8
    add a,h
    add a,8
    ld h,a
    ret

;   hex-
;: HL=   , A=

chrOutHex
    ld e,'.'
    or a
    jr z,chrOut
    ld e,'0'
    cp 10
    jr c,$+4
    ld e,'A'-10
    add a,e

;  
;: HL=   , E= 

chrOutA
    ld e,a
chrOut
    ex de,hl
    ld h,0
    add hl,hl
    add hl,hl
    add hl,hl
    ld a,h
    add a,(fontData/256)-1
    ld h,a
    ex de,hl

    dup 8
    ld a,(de)
    ld (hl),a
    inc e
    inc h
    edup
    org $-2
    ld a,h
    sub 7
    ld h,a
    inc l

    ret

;  
;: H=x,L=y, BC= 

strOut
    call scrPos
.loop0
    ld a,(bc)
    or a
    ret z
    cp #20
    jr nc,.loop1
    ld h,a
    inc bc
    ld a,(bc)
    ld l,a
    inc bc
    jr strOut
.loop1
    call chrOutA
    inc bc
    jr .loop0

;  ,       
;: H=x,L=y, DE=

dec1NumOut
    call scrPos
    jp dec4NumOut.dec1
dec2NumOut
    call scrPos
    jp dec4NumOut.dec2
dec3NumOut
    call scrPos
    jp dec4NumOut.dec3
dec4NumOut
    call scrPos
    ex de,hl
    ld a,'0'
    ld bc,-1000
.loop0
    add hl,bc
    jr nc,.loop1
    inc a
    jp .loop0
.loop1
    sbc hl,bc
    ex de,hl
    push de
    call chrOutA
    pop de
.dec3
    ex de,hl
    ld a,'0'
    ld bc,-100
.loop2
    add hl,bc
    jr nc,.loop3
    inc a
    jp .loop2
.loop3
    sbc hl,bc
    ex de,hl
    push de
    call chrOutA
    pop de
.dec2
    ex de,hl
    ld a,'0'
    ld bc,-10
.loop4
    add hl,bc
    jr nc,.loop5
    inc a
    jp .loop4
.loop5
    sbc hl,bc
    ex de,hl
    push de
    call chrOutA
    pop de
    ld a,e
.dec1
    add a,'0'
    jp chrOutA

;  
;: A= 

waitKey
.loop0
    bit 5,(iy+1)
    jr z,.loop0
    ld a,(23560)
    res 5,(iy+1)
    ret

strTitle    db #06,#08,"Music Synth 48K T.E."
            db #06,#0a,"v1.0  by Shiru 10'09"
            db #02,#10,"Based on beeper music player"
            db #02,#11,"from the Music Synth 48K"
            db #02,#12,#7f,"1989 Simon Tillson",0
strOctave   db "Octave:",0
strEditor   db #12,#05,"Autostep:"
            db #12,#06,"Tempo:"
            db #12,#07,"Length:"
            db #12,#08,"Loop:"
            db #12,#09,"Memory:"
            db #12,#0c,"Paste len:"
            db #1f,#09,"%"
            db #12,#17,"Space for menu",0
strMainMenu db " File Copy Paste Hear Name Info ",0
strFileMenu db " New Load Save                  ",0
strConfirm  db " New? All Track Cancel          ",0
strPlay     db " Playing, press any key to stop ",0
strCopy     db " Block length:                  ",0
strEnvelope db "Envelope:",0
strHelp     db "CS+3,4,5,6,7,8: move cursor",1
            db "SS+Q: jump to start",1
            db "SS+E: jump to end",2
            db "SS+1,2,3,4: select octave",1
            db "SS+5: autostep",1
            db "SS+7: tempo",1
            db "SS+9: set track length",2
            db "Z,S,X,D,C,V,G,B,H,N,J,M: note",1
            db "Q,2,W,3,E,R,5,T,6,Y,7,U: note up",1
            db "A: key off, drum in env.editor",1
            db "CS+9: clear note",1
            db "CS+0: delete note",1
            db "SS+W: insert note",1
            db "CS+1: edit envelope",2
            db "L: set loop start",1
            db "ENTER: hold to play",2
            db 255
noteName    db "C-C#D-D#E-F-F#G-G#A-A#B-"

attrOff     db 6,1,9,0,11,1,14,0,16,0

envGfx
    db %00000000
    db %00111000
    db %00000000
    db %00000000
    db %00000000
    db %00111000
    db %00000000
    db %00000000

    db %00000000
    db %00111000
    db %00000000
    db %00000000
    db %11111110
    db %10000010
    db %10000010
    db %11111110

    db %11111110
    db %10000010
    db %10000010
    db %11111110
    db %00000000
    db %00111000
    db %00000000
    db %00000000

noteKeyTable
    db 33,64,35,36      ; 
    db "zsxdcvgbhnjm"   ; 
    db "q2w3er5t6y7u"   ; 
    db 'a'              ; 
noteTable
    db 128,129,130,131
    db 0,1,2,3,4,5,6,7,8,9,10,11
    db 12,13,14,15,16,17,18,19,20,21,22,23
    db 49

playerData
    incbin "player.bin"

    align 256
noteFreq
    db #00,#00,#00,#00,#00,#00,#ff,#f1,#e3,#d6,#ca,#bf ;F#1 B-1
    db #b4,#aa,#a0,#97,#8e,#86,#7f,#77,#71,#6a,#64,#5e ;C-2 B-2
    db #59,#54,#4f,#4a,#46,#42,#3e,#3b,#37,#34,#31,#2e ;C-3 B-3
    db #2c,#29,#27,#24,#22,#20,#1e,#1c,#1b,#19,#18,#16 ;C-4 B-4
    db #00 ;R

end

    display /d,$-begin

curRow      	dw 0
curCol      	db 0
curOctave   	db 0
autoStep    	dw 0
noiseD      	db 0
noiseW      	db 0
copyLen     	dw 0
copyBufLen  	dw 0
copyBufCol  	db 0
curEnvCol   	db 0
curEnv      	db 0
tuneSize    	dw 0
cmpLen0     	dw 0
cmpLen1     	dw 0
cmpLen2     	dw 0
strNumber   	ds 5
playerStartA	dw 0
playerStartB	dw 0
playerStartC	dw 0
playerLoopA		dw 0
playerLoopB		dw 0
playerLoopC		dw 0

    display $

plrData=#9f00
tuneName=#c500
tuneLength=#c520
tuneTempo=#c522
tuneLoop=#c524
envData=#c600
tuneData=#c800
ch1Note=tuneData+#0000
ch1Env =tuneData+#0800
ch2Note=tuneData+#1000
ch2Env =tuneData+#1800
ch3Env =tuneData+#2000
copyBuf=#f000

    org #7000
scrTable
    ds 256
tagName
    ds 3*256
fontData
    ds 768+24

    display $
 
    ;savesna "main.sna",begin
    savebin "msynthte.bin",begin,end-begin