#include "stdafx.h"

#include <windows.h>
#include <stdlib.h>


#define SADR(x) (((x)-16384+27))


void wordwr(unsigned char *data,int val)
{
	*data++=(val>>8)&0xff;
	*data++=(val&0xff);
}



int main(int argc,char* argv[])
{
	char name[MAX_PATH];
	unsigned char *ay;
	unsigned char *sna;
	FILE *file;
	int size;
	int i,off;

	if(argc<2)
	{
		printf("MSTESNAY (Music Synth 48K T.E. SNA to AY) by Shiru, 10'09\n");
		printf("USAGE: mstesnay.exe filename.sna\n");
		return 0;
	}

	file=fopen(argv[1],"rb");
	if(!file)
	{
		printf("Can't open file\n");
		return 0;
	}

	fseek(file,0,SEEK_END);
	size=ftell(file);
	fseek(file,0,SEEK_SET);

	if(size!=131103&&size!=147487)
	{
		fclose(file);
		printf("Wrong SNA file size\n");
		return 0;
	}

	sna=(unsigned char*)malloc(size);
	fread(sna,size,1,file);
	fclose(file);

	ay=(unsigned char*)malloc(65536);

	memcpy(ay,"ZXAYEMUL",8);
	ay[8]=1;//file version
	ay[9]=3;//player version (3 for 48K support)
	ay[10]=0;//special player, short int
	ay[11]=0;
	wordwr(&ay[12],52-12);//author offset
	wordwr(&ay[14],85-14);//misc offset
	ay[16]=0;//number of songs in file-1
	ay[17]=0;//first song-1
	wordwr(&ay[18],2);//end struct offset
	wordwr(&ay[20],85-20);//NTStr offset
	wordwr(&ay[22],2);//song header offset
	ay[24]=0;//AY A
	ay[25]=1;//AY B
	ay[26]=2;//AY C
	ay[27]=3;//AY Noise
	wordwr(&ay[28],0);//song length (0 for unknown)
	wordwr(&ay[30],0);//fade length
	ay[32]=0;//hireg
	ay[33]=0;//loreg
	wordwr(&ay[34],4);//points offset
	wordwr(&ay[36],8);//data offset
	wordwr(&ay[38],0x8100);//stack
	wordwr(&ay[40],0x9ebc);//init
	wordwr(&ay[42],0x0038);//interrupt
	wordwr(&ay[44],0x9c40);//addr of block in Z80
	wordwr(&ay[46],0x2bc0);//length of block
	wordwr(&ay[48],129-48);//offset to block
	wordwr(&ay[50],0);//end of blocks list
	memcpy(&ay[52],&sna[SADR(0xc500)],32);
	for(i=52;i<52+32;i++) if(ay[i]<32||ay[i]>127) ay[i]=32;
	ay[84]=0;
	memcpy(&ay[85],"Exported from Music Synth 48K T.E. (Beeper)",43);
	ay[128]=0;
	off=sna[SADR(0x9e99)]+sna[SADR(0x9e9a)]*256;
	sna[SADR(0x9e98)]=0x21;
	sna[SADR(0x9e99)]=sna[SADR(off)];
	sna[SADR(0x9e9a)]=sna[SADR(off+1)];
	off=sna[SADR(0x9e9f)]+sna[SADR(0x9ea0)]*256;
	sna[SADR(0x9e9e)]=0x21;
	sna[SADR(0x9e9f)]=sna[SADR(off)];
	sna[SADR(0x9ea0)]=sna[SADR(off+1)];
	off=sna[SADR(0x9ea5)]+sna[SADR(0x9ea6)]*256;
	sna[SADR(0x9ea4)]=0x21;
	sna[SADR(0x9ea5)]=sna[SADR(off)];
	sna[SADR(0x9ea6)]=sna[SADR(off+1)];
	sna[SADR(0x9c45)]=0x98;
	sna[SADR(0x9c46)]=0x9e;
	sna[SADR(0x9cd7)]=0xc3;
	sna[SADR(0x9ebc)]=0x3e;
	sna[SADR(0x9ebd)]=sna[SADR(0xc522)];
	sna[SADR(0x9ebe)]=0;
	off=sna[SADR(0x9ec9)]+sna[SADR(0x9eca)]*256;
	sna[SADR(0x9ec8)]=0x21;
	sna[SADR(0x9ec9)]=sna[SADR(off)];
	sna[SADR(0x9eca)]=sna[SADR(off+1)];
	off=sna[SADR(0x9ecf)]+sna[SADR(0x9ed0)]*256;
	sna[SADR(0x9ece)]=0x21;
	sna[SADR(0x9ecf)]=sna[SADR(off)];
	sna[SADR(0x9ed0)]=sna[SADR(off+1)];
	off=sna[SADR(0x9ed5)]+sna[SADR(0x9ed6)]*256;
	sna[SADR(0x9ed4)]=0x21;
	sna[SADR(0x9ed5)]=sna[SADR(off)];
	sna[SADR(0x9ed6)]=sna[SADR(off+1)];
	memcpy(&ay[129],&sna[SADR(0x9c40)],0x2bc0);

	strcpy(name,argv[1]);
	name[strlen(name)-3]='a';
	name[strlen(name)-2]='y';
	name[strlen(name)-1]=0;
	file=fopen(name,"wb");

	if(!file)
	{
		printf("Can't create file\n");
	}
	else
	{
		fwrite(ay,11119,1,file);
		fclose(file);
	}

	free(ay);
	free(sna);

	return 0;
}